Index: /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/traccoag_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/traccoag_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/traccoag_mod.F90	(revision 4727)
@@ -23,11 +23,11 @@
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_para, only: gather, scatter
-    USE phys_cal_mod, ONLY : year_len, year_cur,mth_cur, day_cur, hour
+    USE phys_cal_mod, ONLY : year_len, year_cur, mth_cur, day_cur, hour
     USE sulfate_aer_mod
     USE phys_local_var_mod, ONLY: stratomask
     USE YOMCST
     USE print_control_mod, ONLY: lunout
-    USE strataer_mod
-
+    USE strataer_local_var_mod
+    
     IMPLICIT NONE
 
@@ -58,4 +58,5 @@
 !----------------
     REAL                                   :: m_aer_emiss_vol_daily ! daily injection mass emission
+    REAL                                   :: m_aer               ! aerosol mass
     INTEGER                                :: it, k, i, ilon, ilev, itime, i_int, ieru
     LOGICAL,DIMENSION(klon,klev)           :: is_strato           ! true = above tropopause, false = below
@@ -78,8 +79,14 @@
     REAL                                   :: theta_min, theta_max ! for SAI computation between two latitudes
     REAL                                   :: dlat_loc
-
-    IF (is_mpi_root) THEN
+    REAL                                   :: latmin,latmax,lonmin,lonmax ! lat/lon min/max for injection
+    REAL                                   :: sigma_alt, altemiss ! injection altitude + sigma for distrib
+    REAL                                   :: pdt,stretchlong     ! physic timestep, stretch emission over one day
+    
+    INTEGER                                :: injdur_sai          ! injection duration for SAI case [days]
+    INTEGER                                :: yr, is_bissext
+
+    IF (is_mpi_root .AND. flag_verbose_strataer) THEN
        WRITE(lunout,*) 'in traccoag: date from phys_cal_mod =',year_cur,'-',mth_cur,'-',day_cur,'-',hour
-       WRITE(lunout,*) 'IN traccoag flag_sulf_emit: ',flag_sulf_emit
+       WRITE(lunout,*) 'IN traccoag flag_emit: ',flag_emit
     ENDIF
     
@@ -124,20 +131,11 @@
 !--calculate mass of air in every grid box
     DO ilon=1, klon
-    DO ilev=1, klev
-      m_air_gridbox(ilon,ilev)=(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG*cell_area(ilon)
+       DO ilev=1, klev
+          m_air_gridbox(ilon,ilev)=(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG*cell_area(ilon)
+       ENDDO
     ENDDO
-    ENDDO
-
-!    IF (debutphy) THEN
-!      CALL gather(tr_seri, tr_seri_glo)
-!      IF (MAXVAL(tr_seri_glo).LT.1.e-30) THEN
-!--initialising tracer concentrations to zero
-!        DO it=1, nbtr
-!        tr_seri(:,:,it)=0.0
-!        ENDDO
-!      ENDIF
-!    ENDIF
-
+    
 !--initialise emission diagnostics
+    budg_emi(:,1)=0.0
     budg_emi_ocs(:)=0.0
     budg_emi_so2(:)=0.0
@@ -145,6 +143,6 @@
     budg_emi_part(:)=0.0
 
-!--sulfur emission, depending on chosen scenario (flag_sulf_emit)
-    SELECT CASE(flag_sulf_emit)
+!--sulfur emission, depending on chosen scenario (flag_emit)
+    SELECT CASE(flag_emit)
 
     CASE(0) ! background aerosol
@@ -157,71 +155,29 @@
           IF (year_cur==year_emit_vol(ieru).AND.mth_cur==mth_emit_vol(ieru).AND.&
                day_cur>=day_emit_vol(ieru).AND.day_cur<(day_emit_vol(ieru)+injdur)) THEN
-             !
-             ! daily injection mass emission - NL
-             m_aer_emiss_vol_daily = m_aer_emiss_vol(ieru)/(REAL(injdur)*REAL(ponde_lonlat_vol(ieru)))
-             WRITE(lunout,*) 'IN traccoag DD m_aer_emiss_vol(ieru)=',m_aer_emiss_vol(ieru), &
+
+             ! daily injection mass emission
+             m_aer=m_aer_emiss_vol(ieru,1)/(REAL(injdur)*REAL(ponde_lonlat_vol(ieru)))
+             !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
+             m_aer=m_aer*(mSO2mol/mSatom)
+             
+             WRITE(lunout,*) 'IN traccoag m_aer_emiss_vol(ieru)=',m_aer_emiss_vol(ieru,1), &
                   'ponde_lonlat_vol(ieru)=',ponde_lonlat_vol(ieru),'(injdur*ponde_lonlat_vol(ieru))', &
-                  (injdur*ponde_lonlat_vol(ieru)),'m_aer_emiss_vol_daily=',m_aer_emiss_vol_daily,'ieru=',ieru
+                  (injdur*ponde_lonlat_vol(ieru)),'m_aer_emiss_vol_daily=',m_aer,'ieru=',ieru
              WRITE(lunout,*) 'IN traccoag, dlon=',dlon
-             DO i=1,klon
-                !Pinatubo eruption at 15.14N, 120.35E
-                dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-                WRITE(lunout,*) 'IN traccoag, dlat=',dlat_loc
-                IF ( xlat(i).GE.xlat_min_vol(ieru)-dlat_loc .AND. xlat(i).LT.xlat_max_vol(ieru)+dlat_loc .AND. &
-                     xlon(i).GE.xlon_min_vol(ieru)-dlon .AND. xlon(i).LT.xlon_max_vol(ieru)+dlon ) THEN
-                   !
-                   WRITE(lunout,*) 'coordinates of volcanic injection point=',xlat(i),xlon(i),day_cur,mth_cur,year_cur
-                   WRITE(lunout,*) 'DD m_aer_emiss_vol_daily=',m_aer_emiss_vol_daily
-                   !         compute altLMDz
-                   altLMDz(:)=0.0
-                   DO k=1, klev
-                      zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
-                      zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
-                      zdz=zdm(k)/zrho                      !thickness of layer in m
-                      altLMDz(k+1)=altLMDz(k)+zdz          !altitude of interface
-                   ENDDO
-
-                   SELECT CASE(flag_sulf_emit_distrib)
-                   
-                   CASE(0) ! Gaussian distribution
-                   !compute distribution of emission to vertical model layers (based on Gaussian peak in altitude)
-                   f_lay_sum=0.0
-                   DO k=1, klev
-                      f_lay_emiss(k)=0.0
-                      DO i_int=1, n_int_alt
-                         alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                         f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt_vol(ieru))* &
-                              &              exp(-0.5*((alt-altemiss_vol(ieru))/sigma_alt_vol(ieru))**2.)*   &
-                              &              (altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                      ENDDO
-                      f_lay_sum=f_lay_sum+f_lay_emiss(k)
-                   ENDDO
-                   
-                   CASE(1) ! Uniform distribution
-                   ! In this case, parameter sigma_alt_vol(ieru) is considered to be half the
-                   ! height of the injection, centered around altemiss_vol(ieru)
-                   DO k=1, klev
-                      f_lay_emiss(k)=max(min(altemiss_vol(ieru)+sigma_alt_vol(ieru),altLMDz(k+1))- &
-                      & max(altemiss_vol(ieru)-sigma_alt_vol(ieru),altLMDz(k)),0.)/(2.*sigma_alt_vol(ieru))
-                      f_lay_sum=f_lay_sum+f_lay_emiss(k)
-                   ENDDO
-
-                   END SELECT        ! End CASE over flag_sulf_emit_distrib)
-
-                   WRITE(lunout,*) "IN traccoag m_aer_emiss_vol=",m_aer_emiss_vol(ieru)
-                   WRITE(lunout,*) "IN traccoag f_lay_emiss=",f_lay_emiss
-                   !correct for step integration error
-                   f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
-                   !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
-                   !vertically distributed emission
-                   DO k=1, klev
-                      ! stretch emission over one day of Pinatubo eruption
-                      emission=m_aer_emiss_vol_daily*(mSO2mol/mSatom)/m_air_gridbox(i,k)*f_lay_emiss(k)/1./(86400.-pdtphys)
-                      tr_seri(i,k,id_SO2_strat)=tr_seri(i,k,id_SO2_strat)+emission*pdtphys
-                      budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
-                   ENDDO
-                ENDIF ! emission grid cell
-             ENDDO ! klon loop
-             WRITE(lunout,*) "IN traccoag (ieru=",ieru,") m_aer_emiss_vol_daily=",m_aer_emiss_vol_daily
+             
+             latmin=xlat_min_vol(ieru)
+             latmax=xlat_max_vol(ieru)
+             lonmin=xlon_min_vol(ieru)
+             lonmax=xlon_max_vol(ieru)
+             altemiss = altemiss_vol(ieru)
+             sigma_alt = sigma_alt_vol(ieru)
+             pdt=pdtphys
+             ! stretch emission over one day of eruption
+             stretchlong = 1.
+             
+             CALL STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,tr_seri,&
+                  m_aer,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_SO2_strat, &
+                  stretchlong,1,0)
+             
           ENDIF ! emission period
        ENDDO ! eruption number
@@ -229,145 +185,124 @@
     CASE(2) ! stratospheric aerosol injections (SAI)
 !
-      DO i=1,klon
-!       SAI standard scenario with continuous emission from 1 grid point at the equator
-!       SAI emission on single month
-!       SAI continuous emission o
-        dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-        IF  ( xlat(i).GE.xlat_sai-dlat_loc .AND. xlat(i).LT.xlat_sai+dlat_loc .AND. &
-          &   xlon(i).GE.xlon_sai-dlon .AND. xlon(i).LT.xlon_sai+dlon ) THEN
-!
-!         compute altLMDz
-          altLMDz(:)=0.0
-          DO k=1, klev
-            zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
-            zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
-            zdz=zdm(k)/zrho                      !thickness of layer in m
-            altLMDz(k+1)=altLMDz(k)+zdz          !altitude of interface
-          ENDDO
-
-          SELECT CASE(flag_sulf_emit_distrib)
-
-          CASE(0) ! Gaussian distribution
-          !compute distribution of emission to vertical model layers (based on Gaussian peak in altitude)
-          f_lay_sum=0.0
-               DO k=1, klev
-                     f_lay_emiss(k)=0.0
-                     DO i_int=1, n_int_alt
-                         alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                         f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt_sai)* &
-                         &              exp(-0.5*((alt-altemiss_sai)/sigma_alt_sai)**2.)*   & 
-                         &              (altLMDz(k+1)-altLMDz(k))/float(n_int_alt) 
-                     ENDDO
-                     f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          CASE(1) ! Uniform distribution
-          f_lay_sum=0.0
-          ! In this case, parameter sigma_alt_vol(ieru) is considered to be half
-          ! the height of the injection, centered around altemiss_sai
-               DO k=1, klev
-                    f_lay_emiss(k)=max(min(altemiss_sai+sigma_alt_sai,altLMDz(k+1))- &
-                    & max(altemiss_sai-sigma_alt_sai,altLMDz(k)),0.)/(2.*sigma_alt_sai)
-                    f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          END SELECT ! Gaussian or uniform distribution
-
-          !correct for step integration error
-          f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
-          !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
-          !vertically distributed emission
-          DO k=1, klev
-            ! stretch emission over whole year (360d)
-            emission=m_aer_emiss_sai*(mSO2mol/mSatom)/m_air_gridbox(i,k)*f_lay_emiss(k)/FLOAT(year_len)/86400.  
-            tr_seri(i,k,id_SO2_strat)=tr_seri(i,k,id_SO2_strat)+emission*pdtphys
-            budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
-          ENDDO
-
-!          !emission as monodisperse particles with 0.1um dry radius (BIN21)
-!          !vertically distributed emission
-!          DO k=1, klev
-!            ! stretch emission over whole year (360d)
-!            emission=m_aer_emiss*(mH2SO4mol/mSatom)/m_part_dry(21)/m_air_gridbox(i,k)*f_lay_emiss(k)/FLOAT(year_len)/86400.
-!            tr_seri(i,k,id_BIN01_strat+20)=tr_seri(i,k,id_BIN01_strat+20)+emission*pdtphys 
-!            budg_emi_part(i)=budg_emi_part(i)+emission*zdm(k)*mSatom/mH2SO4mol
-!          ENDDO
-        ENDIF ! emission grid cell
-      ENDDO ! klon loop
+     ! Computing duration of SAI in days...
+     ! ... starting from 0...
+     injdur_sai = 0
+     ! ... then adding whole years from first to (n-1)th...
+     DO yr = year_emit_sai_start, year_emit_sai_end-1
+       ! (n % 4 == 0) and (n % 100 != 0 or n % 400 == 0)
+       is_bissext = (MOD(yr,4)==0) .AND. (MOD(yr,100) /= 0 .OR. MOD(yr,400) == 0)
+       injdur_sai = injdur_sai+365+is_bissext
+     ENDDO
+     ! ... then subtracting part of the first year where no injection yet...
+     is_bissext = (MOD(year_emit_sai_start,4)==0) .AND. (MOD(year_emit_sai_start,100) /= 0 .OR. MOD(year_emit_sai_start,400) == 0)
+     SELECT CASE(mth_emit_sai_start)
+     CASE(2)
+        injdur_sai = injdur_sai-31
+     CASE(3)
+        injdur_sai = injdur_sai-31-28-is_bissext
+     CASE(4)
+        injdur_sai = injdur_sai-31-28-is_bissext-31
+     CASE(5)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30
+     CASE(6)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31
+     CASE(7)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31-30
+     CASE(8)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31-30-31
+     CASE(9)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31-30-31-31
+     CASE(10)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31-30-31-31-30
+     CASE(11)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31-30-31-31-30-31
+     CASE(12)
+        injdur_sai = injdur_sai-31-28-is_bissext-31-30-31-30-31-31-30-31-30
+     END SELECT
+     injdur_sai = injdur_sai-day_emit_sai_start+1
+     ! ... then adding part of the n-th year 
+     is_bissext = (MOD(year_emit_sai_end,4)==0) .AND. (MOD(year_emit_sai_end,100) /= 0 .OR. MOD(year_emit_sai_end,400) == 0)
+     SELECT CASE(mth_emit_sai_end)
+     CASE(2)
+        injdur_sai = injdur_sai+31
+     CASE(3)
+        injdur_sai = injdur_sai+31+28+is_bissext
+     CASE(4)
+        injdur_sai = injdur_sai+31+28+is_bissext+31
+     CASE(5)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30
+     CASE(6)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31
+     CASE(7)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31+30
+     CASE(8)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31+30+31
+     CASE(9)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31+30+31+31
+     CASE(10)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31+30+31+31+30
+     CASE(11)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31+30+31+31+30+31
+     CASE(12)
+        injdur_sai = injdur_sai+31+28+is_bissext+31+30+31+30+31+31+30+31+30
+     END SELECT
+     injdur_sai = injdur_sai+day_emit_sai_end
+     ! A security: are SAI dates of injection consistent?
+     IF (injdur_sai <= 0) THEN
+        CALL abort_physic('traccoag_mod', 'Pb in SAI dates of injection.',1)
+     ENDIF
+     ! Injection in itself
+     IF (( year_emit_sai_start <= year_cur ) &
+        .AND. ( year_cur <= year_emit_sai_end ) &
+        .AND. ( mth_emit_sai_start <= mth_cur .OR. year_emit_sai_start < year_cur ) &
+        .AND. ( mth_cur <= mth_emit_sai_end .OR. year_cur < year_emit_sai_end ) &
+        .AND. ( day_emit_sai_start <= day_cur .OR. mth_emit_sai_start < mth_cur .OR. year_emit_sai_start < year_cur ) &
+        .AND. ( day_cur <= day_emit_sai_end .OR. mth_cur < mth_emit_sai_end .OR. year_cur < year_emit_sai_end )) THEN
+        
+       m_aer=m_aer_emiss_sai
+       !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
+       m_aer=m_aer*(mSO2mol/mSatom)
+       
+       latmin=xlat_sai
+       latmax=xlat_sai
+       lonmin=xlon_sai
+       lonmax=xlon_sai
+       altemiss = altemiss_sai
+       sigma_alt = sigma_alt_sai
+       pdt=0.
+       ! stretch emission over whole year (360d)
+       stretchlong=FLOAT(year_len)
+       
+       CALL STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,m_air_gridbox,tr_seri,&
+            m_aer,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_SO2_strat, &
+            stretchlong,1,0)
+       
+       budg_emi_so2(:) = budg_emi(:,1)*mSatom/mSO2mol
+     ENDIF ! Condition over injection dates
 
     CASE(3) ! --- SAI injection over a single band of longitude and between
             !     lat_min and lat_max
 
-    DO i=1,klon
-!       SAI scenario with continuous emission
-        dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-        theta_min = max(xlat(i)-dlat_loc,xlat_min_sai)
-        theta_max = min(xlat(i)+dlat_loc,xlat_max_sai)
-        IF  ( xlat(i).GE.xlat_min_sai-dlat_loc .AND. xlat(i).LT.xlat_max_sai+dlat_loc .AND. &
-          &   xlon(i).GE.xlon_sai-dlon .AND. xlon(i).LT.xlon_sai+dlon ) THEN
-!
-!         compute altLMDz
-          altLMDz(:)=0.0
-          DO k=1, klev
-            zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
-            zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
-            zdz=zdm(k)/zrho                      !thickness of layer in m
-            altLMDz(k+1)=altLMDz(k)+zdz          !altitude of interface
-          ENDDO
-
-          SELECT CASE(flag_sulf_emit_distrib)
-
-          CASE(0) ! Gaussian distribution
-          !compute distribution of emission to vertical model layers (based on
-          !Gaussian peak in altitude)
-          f_lay_sum=0.0
-               DO k=1, klev
-                     f_lay_emiss(k)=0.0
-                     DO i_int=1, n_int_alt
-                         alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                         f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt_sai)* &
-                         & exp(-0.5*((alt-altemiss_sai)/sigma_alt_sai)**2.)*   &
-                         & (altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                     ENDDO
-                     f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          CASE(1) ! Uniform distribution
-          f_lay_sum=0.0
-          ! In this case, parameter sigma_alt_vol(ieru) is considered to be half
-          ! the height of the injection, centered around altemiss_sai
-               DO k=1, klev
-                    f_lay_emiss(k)=max(min(altemiss_sai+sigma_alt_sai,altLMDz(k+1))- &
-                    & max(altemiss_sai-sigma_alt_sai,altLMDz(k)),0.)/(2.*sigma_alt_sai)
-                    f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          END SELECT ! Gaussian or uniform distribution
-
-          !correct for step integration error
-          f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
-          !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
-          !vertically distributed emission
-          DO k=1, klev
-            ! stretch emission over whole year (360d)
-            emission=m_aer_emiss_sai*(mSO2mol/mSatom)/m_air_gridbox(i,k)*f_lay_emiss(k)/ &
-                      & FLOAT(year_len)/86400.*(sin(theta_max/180.*RPI)-sin(theta_min/180.*RPI))/ & 
-                      & (sin(xlat_max_sai/180.*RPI)-sin(xlat_min_sai/180.*RPI))
-            tr_seri(i,k,id_SO2_strat)=tr_seri(i,k,id_SO2_strat)+emission*pdtphys
-            budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
-          ENDDO
-
-!          !emission as monodisperse particles with 0.1um dry radius (BIN21)
-!          !vertically distributed emission
-!          DO k=1, klev
-!            ! stretch emission over whole year (360d)
-!            emission=m_aer_emiss*(mH2SO4mol/mSatom)/m_part_dry(21)/m_air_gridbox(i,k)*f_lay_emiss(k)/year_len/86400 
-!            tr_seri(i,k,id_BIN01_strat+20)=tr_seri(i,k,id_BIN01_strat+20)+emission*pdtphys 
-!            budg_emi_part(i)=budg_emi_part(i)+emission*zdm(k)*mSatom/mH2SO4mol
-!          ENDDO
-        ENDIF ! emission grid cell
-      ENDDO ! klon loop
-
-    END SELECT ! emission scenario (flag_sulf_emit)
+       m_aer=m_aer_emiss_sai
+       !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
+       m_aer=m_aer*(mSO2mol/mSatom)
+
+       latmin=xlat_min_sai
+       latmax=xlat_max_sai
+       lonmin=xlon_sai
+       lonmax=xlon_sai
+       altemiss = altemiss_sai
+       sigma_alt = sigma_alt_sai
+       pdt=0.
+       ! stretch emission over whole year (360d)
+       stretchlong=FLOAT(year_len)
+
+       CALL STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,m_air_gridbox,tr_seri,&
+            m_aer,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_SO2_strat, &
+            stretchlong,1,0)
+
+       budg_emi_so2(:) = budg_emi(:,1)*mSatom/mSO2mol
+       
+    END SELECT ! emission scenario (flag_emit)
 
 !--read background concentrations of OCS and SO2 and lifetimes from input file
@@ -387,5 +322,5 @@
     CALL coagulate(pdtphys,mdw,tr_seri,t_seri,pplay,dens_aer,is_strato)
 
-!--call sedimentation routine 
+!--call sedimentation routine
     CALL aer_sedimnt(pdtphys, t_seri, pplay, paprs, tr_seri, dens_aer)
 
@@ -404,10 +339,5 @@
       ENDDO
     ENDDO
-
-!    CALL minmaxsimple(tr_seri(:,:,id_SO2_strat),0.0,0.0,'fin SO2')
-!    DO it=1, nbtr_bin
-!      CALL minmaxsimple(tr_seri(:,:,nbtr_sulgas+it),0.0,0.0,'fin bin ')
-!    ENDDO
-
+    
   END SUBROUTINE traccoag
 
